import { Intersect } from '../intersect/index.mjs';
import { Union } from '../union/index.mjs';
import { CloneType } from '../clone/type.mjs';
import { TIntersect as IsIntersectType, TUnion as IsUnionType, TPromise as IsPromiseType } from '../guard/type.mjs';
function AwaitedUnwrap(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [Resolve(L), ...AwaitedUnwrap(R)]
        : []);
}
function AwaitedIntersectRest(T) {
    return Intersect(AwaitedUnwrap(T));
}
function AwaitedUnionRest(T) {
    return Union(AwaitedUnwrap(T));
}
function AwaitedPromise(T) {
    return Resolve(T);
}
export function Resolve(T) {
    return (IsIntersectType(T) ? AwaitedIntersectRest(T.allOf) :
        IsUnionType(T) ? AwaitedUnionRest(T.anyOf) :
            IsPromiseType(T) ? AwaitedPromise(T.item) :
                T);
}
export function Awaited(T, options = {}) {
    return CloneType(Resolve(T), options);
}
