import type { UnionToTuple, Assert, Evaluate } from '../helpers/index.mjs';
import { type TObject, type ObjectOptions } from '../object/index.mjs';
import { type TIntersect } from '../intersect/index.mjs';
import { IndexedTypeResolve } from '../indexed/index.mjs';
type CompositeKeys<T extends TObject[]> = T extends [infer L extends TObject, ...infer R extends TObject[]] ? keyof L['properties'] | CompositeKeys<R> : never;
type CompositeIndex<T extends TIntersect<TObject[]>, K extends string[]> = K extends [infer L extends string, ...infer R extends string[]] ? {
    [_ in L]: IndexedTypeResolve<T, [L]>;
} & CompositeIndex<T, R> : {};
type CompositeReduce<T extends TObject[]> = UnionToTuple<CompositeKeys<T>> extends infer K ? Evaluate<CompositeIndex<TIntersect<T>, Assert<K, string[]>>> : {};
export type CompositeResolve<T extends TObject[]> = TIntersect<T> extends TIntersect ? TObject<CompositeReduce<T>> : TObject<{}>;
export declare function CompositeResolve<T extends TObject[]>(T: [...T]): CompositeResolve<T>;
export type TComposite<T extends TObject[]> = CompositeResolve<T>;
export declare function Composite<T extends TObject[]>(T: [...T], options?: ObjectOptions): TComposite<T>;
export {};
