import { Object } from '../object/index.mjs';
import { Intersect } from '../intersect/index.mjs';
import { KeyOfStringResolve } from '../keyof/index.mjs';
import { Index } from '../indexed/index.mjs';
import { CloneType } from '../clone/type.mjs';
export function CompositeResolve(T) {
    const intersect = Intersect(T, {});
    const keys = KeyOfStringResolve(intersect);
    const properties = keys.reduce((acc, key) => ({ ...acc, [key]: Index(intersect, [key]) }), {});
    return Object(properties);
}
export function Composite(T, options) {
    return CloneType(CompositeResolve(T), options);
}
