import { TemplateLiteralToUnion } from '../template-literal/index.mjs';
import { Union } from '../union/index.mjs';
import { Never } from '../never/index.mjs';
import { ExtendsCheck, ExtendsResult } from '../extends/index.mjs';
import { CloneType } from '../clone/type.mjs';
import { TTemplateLiteral as IsTemplateLiteralType, TUnion as IsUnionType } from '../guard/type.mjs';
export function ExcludeResolve(L, R) {
    return (IsTemplateLiteralType(L) ? ExcludeResolve(TemplateLiteralToUnion(L), R) :
        IsTemplateLiteralType(R) ? ExcludeResolve(L, TemplateLiteralToUnion(R)) :
            IsUnionType(L) ? (() => {
                const narrowed = L.anyOf.filter((inner) => ExtendsCheck(inner, R) === ExtendsResult.False);
                return (narrowed.length === 1 ? narrowed[0] : Union(narrowed));
            })() :
                ExtendsCheck(L, R) !== ExtendsResult.False ? Never() :
                    L);
}
export function Exclude(unionType, excludedMembers, options = {}) {
    const E = ExcludeResolve(unionType, excludedMembers);
    return CloneType(E, options);
}
