import { Union } from '../union/index.mjs';
import { ExtendsCheck, ExtendsResult } from './extends-check.mjs';
import { CloneType } from '../clone/type.mjs';
export function ExtendsResolve(left, right, trueType, falseType) {
    const R = ExtendsCheck(left, right);
    return (R === ExtendsResult.Union ? Union([trueType, falseType]) :
        R === ExtendsResult.True ? trueType :
            falseType);
}
export function Extends(L, R, T, F, options = {}) {
    const E = ExtendsResolve(L, R, T, F);
    return CloneType(E, options);
}
