import type { TSchema, SchemaOptions } from '../schema/index.mjs';
import type { Assert, AssertRest, AssertType, UnionToTuple } from '../helpers/index.mjs';
import { type TTemplateLiteral } from '../template-literal/index.mjs';
import { type TLiteral } from '../literal/index.mjs';
import { type TUnion } from '../union/index.mjs';
import { type Static } from '../static/index.mjs';
import { UnionResolve } from '../union/index.mjs';
type FromTemplateLiteralResult<T extends string> = UnionResolve<AssertRest<UnionToTuple<{
    [K in T]: TLiteral<K>;
}[T]>>>;
type FromTemplateLiteral<T extends TTemplateLiteral, U extends TSchema> = Extract<Static<T>, Static<U>> extends infer S ? FromTemplateLiteralResult<Assert<S, string>> : never;
type FromArray<T extends TSchema[], U extends TSchema> = AssertRest<UnionToTuple<{
    [K in keyof T]: Static<AssertType<T[K]>> extends Static<U> ? T[K] : never;
}[number]>> extends infer R extends TSchema[] ? UnionResolve<R> : never;
export type ExtractResolve<T extends TSchema, U extends TSchema> = (T extends TTemplateLiteral ? FromTemplateLiteral<T, U> : T extends TUnion<infer S> ? FromArray<S, U> : T extends U ? T : T);
export declare function ExtractResolve<L extends TSchema, R extends TSchema>(L: L, R: R): ExtractResolve<L, R>;
export type TExtract<T extends TSchema, U extends TSchema> = ExtractResolve<T, U>;
export declare function Extract<L extends TSchema, R extends TSchema>(type: L, union: R, options?: SchemaOptions): TExtract<L, R>;
export {};
