import { Kind, Hint, TransformKind } from '../symbols/index.mjs';
import type { TransformOptions } from '../transform/index.mjs';
import type { TTemplateLiteral, TTemplateLiteralKind } from '../template-literal/index.mjs';
import type { TArray } from '../array/index.mjs';
import type { TBoolean } from '../boolean/index.mjs';
import type { TRecord } from '../record/index.mjs';
import type { TString } from '../string/index.mjs';
import type { TUnion } from '../union/index.mjs';
import type { TAny } from '../any/index.mjs';
import type { TAsyncIterator } from '../async-iterator/index.mjs';
import type { TBigInt } from '../bigint/index.mjs';
import type { TConstructor } from '../constructor/index.mjs';
import type { TFunction } from '../function/index.mjs';
import type { TInteger } from '../integer/index.mjs';
import type { TIntersect } from '../intersect/index.mjs';
import type { TIterator } from '../iterator/index.mjs';
import type { TLiteral } from '../literal/index.mjs';
import type { TNever } from '../never/index.mjs';
import type { TNot } from '../not/index.mjs';
import type { TNull } from '../null/index.mjs';
import type { TNumber } from '../number/index.mjs';
import type { TObject } from '../object/index.mjs';
import type { TOptional } from '../optional/index.mjs';
import type { TPromise } from '../promise/index.mjs';
import type { TReadonly } from '../readonly/index.mjs';
import type { TRef } from '../ref/index.mjs';
import type { TSchema } from '../schema/index.mjs';
import type { TSymbol } from '../symbol/index.mjs';
import type { TTuple } from '../tuple/index.mjs';
import type { TUint8Array } from '../uint8array/index.mjs';
import type { TUndefined } from '../undefined/index.mjs';
import type { TUnknown } from '../unknown/index.mjs';
import type { TUnsafe } from '../unsafe/index.mjs';
import type { TVoid } from '../void/index.mjs';
import type { TDate } from '../date/index.mjs';
import type { TThis } from '../recursive/index.mjs';
export declare class TypeGuardUnknownTypeError extends Error {
}
export declare function TReadonly<T extends TSchema>(schema: T): schema is TReadonly<T>;
export declare function TOptional<T extends TSchema>(schema: T): schema is TOptional<T>;
export declare function TAny(schema: unknown): schema is TAny;
export declare function TArray(schema: unknown): schema is TArray;
export declare function TAsyncIterator(schema: unknown): schema is TAsyncIterator;
export declare function TBigInt(schema: unknown): schema is TBigInt;
export declare function TBoolean(schema: unknown): schema is TBoolean;
export declare function TConstructor(schema: unknown): schema is TConstructor;
export declare function TDate(schema: unknown): schema is TDate;
export declare function TFunction(schema: unknown): schema is TFunction;
export declare function TInteger(schema: unknown): schema is TInteger;
export declare function TIntersect(schema: unknown): schema is TIntersect;
export declare function TIterator(schema: unknown): schema is TIterator;
export declare function TKindOf<T extends string>(schema: unknown, kind: T): schema is Record<PropertyKey, unknown> & {
    [Kind]: T;
};
export declare function TLiteralString(schema: unknown): schema is TLiteral<string>;
export declare function TLiteralNumber(schema: unknown): schema is TLiteral<number>;
export declare function TLiteralBoolean(schema: unknown): schema is TLiteral<boolean>;
export declare function TLiteral(schema: unknown): schema is TLiteral;
export declare function TNever(schema: unknown): schema is TNever;
export declare function TNot(schema: unknown): schema is TNot;
export declare function TNull(schema: unknown): schema is TNull;
export declare function TNumber(schema: unknown): schema is TNumber;
export declare function TObject(schema: unknown): schema is TObject;
export declare function TPromise(schema: unknown): schema is TPromise;
export declare function TRecord(schema: unknown): schema is TRecord;
export declare function TRecursive(schema: unknown): schema is {
    [Hint]: 'Recursive';
};
export declare function TRef(schema: unknown): schema is TRef;
export declare function TString(schema: unknown): schema is TString;
export declare function TSymbol(schema: unknown): schema is TSymbol;
export declare function TTemplateLiteral(schema: unknown): schema is TTemplateLiteral<TTemplateLiteralKind[]>;
export declare function TThis(schema: unknown): schema is TThis;
export declare function TTransform(schema: unknown): schema is {
    [TransformKind]: TransformOptions;
};
export declare function TTuple(schema: unknown): schema is TTuple;
export declare function TUndefined(schema: unknown): schema is TUndefined;
export declare function TUnionLiteral(schema: unknown): schema is TUnion<TLiteral[]>;
export declare function TUnion(schema: unknown): schema is TUnion;
export declare function TUint8Array(schema: unknown): schema is TUint8Array;
export declare function TUnknown(schema: unknown): schema is TUnknown;
export declare function TUnsafe(schema: unknown): schema is TUnsafe<unknown>;
export declare function TVoid(schema: unknown): schema is TVoid;
export declare function TKind(schema: unknown): schema is Record<PropertyKey, unknown> & {
    [Kind]: string;
};
export declare function TSchema(schema: unknown): schema is TSchema;
