export function IsAsyncIterator(value) {
    return IsObject(value) && !IsArray(value) && !IsUint8Array(value) && Symbol.asyncIterator in value;
}
export function IsArray(value) {
    return Array.isArray(value);
}
export function IsBigInt(value) {
    return typeof value === 'bigint';
}
export function IsBoolean(value) {
    return typeof value === 'boolean';
}
export function IsDate(value) {
    return value instanceof globalThis.Date;
}
export function IsFunction(value) {
    return typeof value === 'function';
}
export function IsIterator(value) {
    return IsObject(value) && !IsArray(value) && !IsUint8Array(value) && Symbol.iterator in value;
}
export function IsNull(value) {
    return value === null;
}
export function IsNumber(value) {
    return typeof value === 'number';
}
export function IsObject(value) {
    return typeof value === 'object' && value !== null;
}
export function IsString(value) {
    return typeof value === 'string';
}
export function IsSymbol(value) {
    return typeof value === 'symbol';
}
export function IsUint8Array(value) {
    return value instanceof globalThis.Uint8Array;
}
export function IsUndefined(value) {
    return value === undefined;
}
