import { TemplateLiteralParseExact, IsTemplateLiteralFinite, TemplateLiteralToUnion } from '../template-literal/index.mjs';
import { TTemplateLiteral as IsTemplateLiteralType, TUnionLiteral as IsUnionLiteralType, TUnion as IsUnionType, TLiteral as IsLiteralType, TNumber as IsNumberType, TInteger as IsIntegerType } from '../guard/type.mjs';
function FromTemplateLiteral(T) {
    const E = TemplateLiteralParseExact(T.pattern);
    const F = IsTemplateLiteralFinite(E);
    const S = TemplateLiteralToUnion(T);
    return (F === true
        ? IsUnionLiteralType(S)
            ? S.anyOf.map(S => S.const.toString())
            : []
        : []);
}
function FromUnion(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [...IndexedKeyResolve(L), ...FromUnion(R)]
        : []);
}
function FromLiteral(T) {
    return ([T.toString()]);
}
export function IndexedKeyResolve(T) {
    return [...new Set((IsTemplateLiteralType(T) ? FromTemplateLiteral(T) :
            IsUnionType(T) ? FromUnion(T.anyOf) :
                IsLiteralType(T) ? FromLiteral(T.const) :
                    IsNumberType(T) ? ['[number]'] :
                        IsIntegerType(T) ? ['[number]'] :
                            []))];
}
