import type { TSchema, SchemaOptions } from '../schema/index.mjs';
import { IndexedTypeResolve } from './indexed-type.mjs';
import { IndexedKeyResolve } from './indexed-key.mjs';
export type TIndex<T extends TSchema, K extends PropertyKey[]> = IndexedTypeResolve<T, K>;
export declare function Index<T extends TSchema, K extends TSchema, I extends PropertyKey[] = IndexedKeyResolve<K>>(T: T, K: K, options?: SchemaOptions): TIndex<T, I>;
export declare function Index<T extends TSchema, K extends PropertyKey[]>(T: T, K: readonly [...K], options?: SchemaOptions): TIndex<T, K>;
