import type { TupleToIntersect, AssertType } from '../helpers/index.mjs';
import type { TSchema, SchemaOptions } from '../schema/index.mjs';
import type { Static } from '../static/index.mjs';
import { type TNever } from '../never/index.mjs';
import { OptionalFromIntersect } from '../modifiers/index.mjs';
import { Kind } from '../symbols/index.mjs';
export type IntersectResolve<T extends TSchema[]> = (T extends [] ? TNever : T extends [TSchema] ? T[0] : OptionalFromIntersect<T>);
export declare function IntersectResolve<T extends TSchema[]>(T: T): IntersectResolve<T>;
export type TUnevaluatedProperties = undefined | TSchema | boolean;
export interface IntersectOptions extends SchemaOptions {
    unevaluatedProperties?: TUnevaluatedProperties;
}
export interface TIntersect<T extends TSchema[] = TSchema[]> extends TSchema, IntersectOptions {
    [Kind]: 'Intersect';
    static: TupleToIntersect<{
        [K in keyof T]: Static<AssertType<T[K]>, this['params']>;
    }>;
    type?: 'object';
    allOf: [...T];
}
export declare function Intersect<T extends TSchema[]>(T: [...T], options?: IntersectOptions): IntersectResolve<T>;
