import { Literal } from '../literal/index.mjs';
import { Number } from '../number/index.mjs';
import { KeyOfStringResolve } from './keyof-string.mjs';
import { UnionResolve } from '../union/index.mjs';
function FromLiterals(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? L === '[number]'
            ? [Number(), ...FromLiterals(R)]
            : [Literal(L), ...FromLiterals(R)]
        : []);
}
export function KeyOfTypeResolve(T) {
    return (UnionResolve(FromLiterals(KeyOfStringResolve(T))));
}
