import { Object } from '../object/index.mjs';
import { Literal } from '../literal/index.mjs';
import { IndexedKeyResolve } from '../indexed/indexed-key.mjs';
import { TSchema as IsSchemaType } from '../guard/type.mjs';
import { Kind } from '../symbols/index.mjs';
export function Mapped(key, map) {
    const keys = IsSchemaType(key) ? IndexedKeyResolve(key) : key;
    const anyOf = keys.map(key => Literal(key));
    const mapped = { [Kind]: 'MappedKey', anyOf };
    const properties = keys.reduce((acc, key) => {
        return { ...acc, [key]: map(mapped) };
    }, {});
    return Object(properties);
}
