import { Intersect } from '../intersect/index.mjs';
import { Union } from '../union/index.mjs';
import { Optional } from '../optional/index.mjs';
import { Discard } from '../discard/index.mjs';
import { OptionalKind } from '../symbols/index.mjs';
import { TOptional as IsOptionalType } from '../guard/type.mjs';
function IsOptionalFromIntersect(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? IsOptionalType(L)
            ? IsOptionalFromIntersect(R)
            : false
        : true);
}
function IsOptionalFromUnion(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? IsOptionalType(L)
            ? true
            : IsOptionalFromUnion(R)
        : false);
}
function RemoveOptionalFromRest(T) {
    return (T.map(T => RemoveOptionalFromSchema(T)));
}
function RemoveOptionalFromSchema(T) {
    return (Discard(T, [OptionalKind]));
}
export function OptionalFromIntersect(T) {
    const D = RemoveOptionalFromRest(T);
    return (IsOptionalFromIntersect(T)
        ? Optional(Intersect(D))
        : Intersect(T));
}
export function OptionalFromUnion(T) {
    const D = RemoveOptionalFromRest(T);
    return (IsOptionalFromUnion(T)
        ? Optional(Union(D))
        : Union(T));
}
