export function OperatorIncludes(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? S === L
            ? true
            : OperatorIncludes(R, S)
        : false);
}
export function OperatorSubset(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? OperatorSubset(R, S)
            : false
        : true);
}
export function OperatorDistinct(T, Acc = []) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(Acc, L) === false
            ? OperatorDistinct(R, [...Acc, L])
            : OperatorDistinct(R, [...Acc])
        : Acc);
}
export function OperatorIntersect(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [L, ...OperatorIntersect(R, S)]
            : [...OperatorIntersect(R, S)]
        : []);
}
export function OperatorUnion(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [...OperatorUnion(R, S)]
            : [L, ...OperatorUnion(R, S)]
        : S);
}
export function OperatorComplement(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [...OperatorComplement(R, S)]
            : [L, ...OperatorComplement(R, S)]
        : []);
}
export function OperatorIntersectMany(T) {
    return (T.length === 1
        ? T[0]
        : (() => {
            const [L, ...R] = T;
            return (L.length > 0
                ? OperatorIntersect(L, OperatorIntersectMany(R))
                : []);
        })());
}
export function OperatorUnionMany(T) {
    return (T.length === 1
        ? T[0]
        : (() => {
            const [L, ...R] = T;
            return T.length > 0 ? OperatorUnion(L, OperatorUnionMany(R)) : [];
        })());
}
