import type { TSchema, SchemaOptions } from '../schema/index.mjs';
import { Kind, Hint } from '../symbols/index.mjs';
import { Static } from '../static/index.mjs';
export interface TThis extends TSchema {
    [Kind]: 'This';
    static: this['params'][0];
    $ref: string;
}
export type RecursiveResolve<T extends TSchema> = Static<T, [RecursiveResolve<T>]>;
export interface TRecursive<T extends TSchema> extends TSchema {
    [Hint]: 'Recursive';
    static: RecursiveResolve<T>;
}
export declare function Recursive<T extends TSchema>(callback: (thisType: TThis) => T, options?: SchemaOptions): TRecursive<T>;
