import { CloneType } from '../clone/type.mjs';
import { IsUndefined } from '../guard/value.mjs';
import { Kind, Hint } from '../symbols/index.mjs';
let Ordinal = 0;
export function Recursive(callback, options = {}) {
    if (IsUndefined(options.$id))
        options.$id = `T${Ordinal++}`;
    const thisType = callback({ [Kind]: 'This', $ref: `${options.$id}` });
    thisType.$id = options.$id;
    return CloneType({
        ...options,
        [Hint]: 'Recursive',
        ...thisType,
    });
}
