import type { TSchema } from '../schema/index.mjs';
import type { TIntersect } from '../intersect/index.mjs';
import type { TUnion } from '../union/index.mjs';
import type { TTuple } from '../tuple/index.mjs';
export type RestResolve<T extends TSchema> = T extends TIntersect<infer S> ? [...S] : T extends TUnion<infer S> ? [...S] : T extends TTuple<infer S> ? [...S] : [
];
export declare function RestResolve<T extends TSchema>(T: T): RestResolve<T>;
export type TRest<T extends TSchema> = RestResolve<T>;
export declare function Rest<T extends TSchema>(T: T): TRest<T>;
