import { Union } from '../union/index.mjs';
import { Literal } from '../literal/index.mjs';
import { String } from '../string/index.mjs';
import { TemplateLiteralGenerate } from './generate.mjs';
import { TemplateLiteralParseExact } from './parser.mjs';
import { IsTemplateLiteralFinite } from './finite.mjs';
export function TemplateLiteralToUnion(template) {
    const expression = TemplateLiteralParseExact(template.pattern);
    if (!IsTemplateLiteralFinite(expression))
        return String();
    const literals = [...TemplateLiteralGenerate(expression)].map((value) => Literal(value));
    return Union(literals);
}
