import { JsonTypeBuilder } from './json.mjs';
import { AsyncIterator } from '../async-iterator/index.mjs';
import { Awaited } from '../awaited/index.mjs';
import { BigInt } from '../bigint/index.mjs';
import { Constructor } from '../constructor/index.mjs';
import { ConstructorParameters } from '../constructor-parameters/index.mjs';
import { Date } from '../date/index.mjs';
import { Function } from '../function/index.mjs';
import { InstanceType } from '../instance-type/index.mjs';
import { Iterator } from '../iterator/index.mjs';
import { Parameters } from '../parameters/index.mjs';
import { Promise } from '../promise/index.mjs';
import { RegExp } from '../regexp/index.mjs';
import { ReturnType } from '../return-type/index.mjs';
import { Symbol } from '../symbol/index.mjs';
import { Uint8Array } from '../uint8array/index.mjs';
import { Undefined } from '../undefined/index.mjs';
import { Void } from '../void/index.mjs';
export class JavaScriptTypeBuilder extends JsonTypeBuilder {
    AsyncIterator(items, options = {}) {
        return AsyncIterator(items, options);
    }
    Awaited(schema, options = {}) {
        return Awaited(schema, options);
    }
    BigInt(options = {}) {
        return BigInt(options);
    }
    ConstructorParameters(schema, options = {}) {
        return ConstructorParameters(schema, options);
    }
    Constructor(parameters, returns, options) {
        return Constructor(parameters, returns, options);
    }
    Date(options = {}) {
        return Date(options);
    }
    Function(parameters, returns, options) {
        return Function(parameters, returns, options);
    }
    InstanceType(schema, options = {}) {
        return InstanceType(schema, options);
    }
    Iterator(items, options = {}) {
        return Iterator(items, options);
    }
    Parameters(schema, options = {}) {
        return Parameters(schema, options);
    }
    Promise(item, options = {}) {
        return Promise(item, options);
    }
    RegExp(unresolved, options = {}) {
        return RegExp(unresolved, options);
    }
    ReturnType(schema, options = {}) {
        return ReturnType(schema, options);
    }
    Symbol(options) {
        return Symbol(options);
    }
    Undefined(options = {}) {
        return Undefined(options);
    }
    Uint8Array(options = {}) {
        return Uint8Array(options);
    }
    Void(options = {}) {
        return Void(options);
    }
}
