import { Any } from '../any/index.mjs';
import { Array } from '../array/index.mjs';
import { Boolean } from '../boolean/index.mjs';
import { Composite } from '../composite/index.mjs';
import { Const } from '../const/index.mjs';
import { Deref } from '../deref/index.mjs';
import { Enum } from '../enum/index.mjs';
import { Exclude } from '../exclude/index.mjs';
import { Extends } from '../extends/index.mjs';
import { Extract } from '../extract/index.mjs';
import { Index } from '../indexed/index.mjs';
import { Integer } from '../integer/index.mjs';
import { Intersect } from '../intersect/index.mjs';
import { Capitalize, Uncapitalize, Lowercase, Uppercase } from '../intrinsic/index.mjs';
import { KeyOf } from '../keyof/index.mjs';
import { Literal } from '../literal/index.mjs';
import { Never } from '../never/index.mjs';
import { Not } from '../not/index.mjs';
import { Null } from '../null/index.mjs';
import { Number } from '../number/index.mjs';
import { Object } from '../object/index.mjs';
import { Omit } from '../omit/index.mjs';
import { Optional } from '../optional/index.mjs';
import { Partial } from '../partial/index.mjs';
import { Pick } from '../pick/index.mjs';
import { Readonly } from '../readonly/index.mjs';
import { ReadonlyOptional } from '../readonly-optional/index.mjs';
import { Record } from '../record/index.mjs';
import { Recursive } from '../recursive/index.mjs';
import { Ref } from '../ref/index.mjs';
import { Required } from '../required/index.mjs';
import { Rest } from '../rest/index.mjs';
import { Strict } from '../strict/index.mjs';
import { String } from '../string/index.mjs';
import { TemplateLiteral } from '../template-literal/index.mjs';
import { Transform } from '../transform/index.mjs';
import { Tuple } from '../tuple/index.mjs';
import { Union } from '../union/index.mjs';
import { Unknown } from '../unknown/index.mjs';
import { Unsafe } from '../unsafe/index.mjs';
export class JsonTypeBuilder {
    Strict(schema) {
        return Strict(schema);
    }
    ReadonlyOptional(schema) {
        return ReadonlyOptional(schema);
    }
    Readonly(schema) {
        return Readonly(schema);
    }
    Optional(schema) {
        return Optional(schema);
    }
    Any(options = {}) {
        return Any(options);
    }
    Array(schema, options = {}) {
        return Array(schema, options);
    }
    Boolean(options = {}) {
        return Boolean(options);
    }
    Capitalize(schema, options = {}) {
        return Capitalize(schema, options);
    }
    Composite(objects, options) {
        return Composite(objects, options);
    }
    Const(value, options = {}) {
        return Const(value, options);
    }
    Deref(schema, references) {
        return Deref(schema, references);
    }
    Enum(item, options = {}) {
        return Enum(item, options);
    }
    Extends(left, right, trueType, falseType, options = {}) {
        return Extends(left, right, trueType, falseType, options);
    }
    Exclude(unionType, excludedMembers, options = {}) {
        return Exclude(unionType, excludedMembers, options);
    }
    Extract(type, union, options = {}) {
        return Extract(type, union, options);
    }
    Index(schema, unresolved, options = {}) {
        return Index(schema, unresolved, options);
    }
    Integer(options = {}) {
        return Integer(options);
    }
    Intersect(T, options = {}) {
        return Intersect(T, options);
    }
    KeyOf(schema, options = {}) {
        return KeyOf(schema, options);
    }
    Literal(value, options = {}) {
        return Literal(value, options);
    }
    Lowercase(schema, options = {}) {
        return Lowercase(schema, options);
    }
    Never(options = {}) {
        return Never(options);
    }
    Not(schema, options) {
        return Not(schema, options);
    }
    Null(options = {}) {
        return Null(options);
    }
    Number(options = {}) {
        return Number(options);
    }
    Object(properties, options = {}) {
        return Object(properties, options);
    }
    Omit(schema, unresolved, options = {}) {
        return Omit(schema, unresolved, options);
    }
    Partial(schema, options = {}) {
        return Partial(schema, options);
    }
    Pick(schema, unresolved, options = {}) {
        return Pick(schema, unresolved, options);
    }
    Record(key, schema, options = {}) {
        return Record(key, schema);
    }
    Recursive(callback, options = {}) {
        return Recursive(callback, options);
    }
    Ref(unresolved, options = {}) {
        return Ref(unresolved, options);
    }
    Required(schema, options = {}) {
        return Required(schema, options);
    }
    Rest(schema) {
        return Rest(schema);
    }
    String(options = {}) {
        return String(options);
    }
    TemplateLiteral(unresolved, options = {}) {
        return TemplateLiteral(unresolved, options);
    }
    Transform(schema) {
        return Transform(schema);
    }
    Tuple(items, options = {}) {
        return Tuple(items, options);
    }
    Uncapitalize(schema, options = {}) {
        return Uncapitalize(schema, options);
    }
    Union(schemas, options = {}) {
        return Union(schemas, options);
    }
    Unknown(options = {}) {
        return Unknown(options);
    }
    Unsafe(options = {}) {
        return Unsafe(options);
    }
    Uppercase(schema, options = {}) {
        return Uppercase(schema, options);
    }
}
