import { Never } from '../never/index.mjs';
import { OptionalFromUnion } from '../modifiers/index.mjs';
import { CloneType, CloneRest } from '../clone/type.mjs';
import { Kind } from '../symbols/index.mjs';
export function UnionResolve(T) {
    return (T.length === 0 ? Never() :
        T.length === 1 ? T[0] :
            OptionalFromUnion(T));
}
export function Union(T, options = {}) {
    return (T.length === 0 ? Never(options) :
        T.length === 1 ? CloneType(T[0], options) :
            { ...options, [Kind]: 'Union', anyOf: CloneRest(T)
            });
}
