import type { TSchema } from '../../type/schema/index.mjs';
import type { Static } from '../../type/static/index.mjs';
export declare class ValueCastArrayUniqueItemsTypeError extends Error {
    readonly schema: TSchema;
    readonly value: unknown;
    constructor(schema: TSchema, value: unknown);
}
export declare class ValueCastNeverTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCastRecursiveTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCastUnknownTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare function Cast<T extends TSchema>(schema: T, references: TSchema[], value: unknown): Static<T>;
export declare function Cast<T extends TSchema>(schema: T, value: unknown): Static<T>;
