import type { TSchema, SchemaOptions } from '../schema/index';
import type { Static } from '../static/index';
import { Kind } from '../symbols/index';
export interface ArrayOptions extends SchemaOptions {
    minItems?: number;
    maxItems?: number;
    uniqueItems?: boolean;
    contains?: TSchema;
    minContains?: number;
    maxContains?: number;
}
export interface TArray<T extends TSchema = TSchema> extends TSchema, ArrayOptions {
    [Kind]: 'Array';
    static: Static<T, this['params']>[];
    type: 'array';
    items: T;
}
export declare function Array<T extends TSchema>(schema: T, options?: ArrayOptions): TArray<T>;
