"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Awaited = exports.Resolve = void 0;
const index_1 = require("../intersect/index");
const index_2 = require("../union/index");
const type_1 = require("../clone/type");
const type_2 = require("../guard/type");
function AwaitedUnwrap(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [Resolve(L), ...AwaitedUnwrap(R)]
        : []);
}
function AwaitedIntersectRest(T) {
    return (0, index_1.Intersect)(AwaitedUnwrap(T));
}
function AwaitedUnionRest(T) {
    return (0, index_2.Union)(AwaitedUnwrap(T));
}
function AwaitedPromise(T) {
    return Resolve(T);
}
function Resolve(T) {
    return ((0, type_2.TIntersect)(T) ? AwaitedIntersectRest(T.allOf) :
        (0, type_2.TUnion)(T) ? AwaitedUnionRest(T.anyOf) :
            (0, type_2.TPromise)(T) ? AwaitedPromise(T.item) :
                T);
}
exports.Resolve = Resolve;
function Awaited(T, options = {}) {
    return (0, type_1.CloneType)(Resolve(T), options);
}
exports.Awaited = Awaited;
