"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Exclude = exports.ExcludeResolve = void 0;
const index_1 = require("../template-literal/index");
const index_2 = require("../union/index");
const index_3 = require("../never/index");
const index_4 = require("../extends/index");
const type_1 = require("../clone/type");
const type_2 = require("../guard/type");
function ExcludeResolve(L, R) {
    return ((0, type_2.TTemplateLiteral)(L) ? ExcludeResolve((0, index_1.TemplateLiteralToUnion)(L), R) :
        (0, type_2.TTemplateLiteral)(R) ? ExcludeResolve(L, (0, index_1.TemplateLiteralToUnion)(R)) :
            (0, type_2.TUnion)(L) ? (() => {
                const narrowed = L.anyOf.filter((inner) => (0, index_4.ExtendsCheck)(inner, R) === index_4.ExtendsResult.False);
                return (narrowed.length === 1 ? narrowed[0] : (0, index_2.Union)(narrowed));
            })() :
                (0, index_4.ExtendsCheck)(L, R) !== index_4.ExtendsResult.False ? (0, index_3.Never)() :
                    L);
}
exports.ExcludeResolve = ExcludeResolve;
function Exclude(unionType, excludedMembers, options = {}) {
    const E = ExcludeResolve(unionType, excludedMembers);
    return (0, type_1.CloneType)(E, options);
}
exports.Exclude = Exclude;
