"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsUndefined = exports.IsUint8Array = exports.IsSymbol = exports.IsString = exports.IsObject = exports.IsNumber = exports.IsNull = exports.IsIterator = exports.IsFunction = exports.IsDate = exports.IsBoolean = exports.IsBigInt = exports.IsArray = exports.IsAsyncIterator = void 0;
function IsAsyncIterator(value) {
    return IsObject(value) && !IsArray(value) && !IsUint8Array(value) && Symbol.asyncIterator in value;
}
exports.IsAsyncIterator = IsAsyncIterator;
function IsArray(value) {
    return Array.isArray(value);
}
exports.IsArray = IsArray;
function IsBigInt(value) {
    return typeof value === 'bigint';
}
exports.IsBigInt = IsBigInt;
function IsBoolean(value) {
    return typeof value === 'boolean';
}
exports.IsBoolean = IsBoolean;
function IsDate(value) {
    return value instanceof globalThis.Date;
}
exports.IsDate = IsDate;
function IsFunction(value) {
    return typeof value === 'function';
}
exports.IsFunction = IsFunction;
function IsIterator(value) {
    return IsObject(value) && !IsArray(value) && !IsUint8Array(value) && Symbol.iterator in value;
}
exports.IsIterator = IsIterator;
function IsNull(value) {
    return value === null;
}
exports.IsNull = IsNull;
function IsNumber(value) {
    return typeof value === 'number';
}
exports.IsNumber = IsNumber;
function IsObject(value) {
    return typeof value === 'object' && value !== null;
}
exports.IsObject = IsObject;
function IsString(value) {
    return typeof value === 'string';
}
exports.IsString = IsString;
function IsSymbol(value) {
    return typeof value === 'symbol';
}
exports.IsSymbol = IsSymbol;
function IsUint8Array(value) {
    return value instanceof globalThis.Uint8Array;
}
exports.IsUint8Array = IsUint8Array;
function IsUndefined(value) {
    return value === undefined;
}
exports.IsUndefined = IsUndefined;
