"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndexedKeyResolve = void 0;
const index_1 = require("../template-literal/index");
const type_1 = require("../guard/type");
function FromTemplateLiteral(T) {
    const E = (0, index_1.TemplateLiteralParseExact)(T.pattern);
    const F = (0, index_1.IsTemplateLiteralFinite)(E);
    const S = (0, index_1.TemplateLiteralToUnion)(T);
    return (F === true
        ? (0, type_1.TUnionLiteral)(S)
            ? S.anyOf.map(S => S.const.toString())
            : []
        : []);
}
function FromUnion(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [...IndexedKeyResolve(L), ...FromUnion(R)]
        : []);
}
function FromLiteral(T) {
    return ([T.toString()]);
}
function IndexedKeyResolve(T) {
    return [...new Set(((0, type_1.TTemplateLiteral)(T) ? FromTemplateLiteral(T) :
            (0, type_1.TUnion)(T) ? FromUnion(T.anyOf) :
                (0, type_1.TLiteral)(T) ? FromLiteral(T.const) :
                    (0, type_1.TNumber)(T) ? ['[number]'] :
                        (0, type_1.TInteger)(T) ? ['[number]'] :
                            []))];
}
exports.IndexedKeyResolve = IndexedKeyResolve;
