"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Intersect = exports.IntersectResolve = void 0;
const index_1 = require("../never/index");
const index_2 = require("../modifiers/index");
const index_3 = require("../symbols/index");
const type_1 = require("../clone/type");
const type_2 = require("../guard/type");
function IntersectResolve(T) {
    return (T.length === 0
        ? (0, index_1.Never)()
        : T.length === 1
            ? T[0]
            : (0, index_2.OptionalFromIntersect)(T));
}
exports.IntersectResolve = IntersectResolve;
function Intersect(T, options = {}) {
    if (T.length === 0)
        return (0, index_1.Never)();
    if (T.length === 1)
        return (0, type_1.CloneType)(T[0], options);
    if (T.some((schema) => (0, type_2.TTransform)(schema)))
        throw new Error('Cannot intersect transform types');
    const allObjects = T.every((schema) => (0, type_2.TObject)(schema));
    const clonedUnevaluatedProperties = (0, type_2.TSchema)(options.unevaluatedProperties) ? { unevaluatedProperties: (0, type_1.CloneType)(options.unevaluatedProperties) } : {};
    return (options.unevaluatedProperties === false || (0, type_2.TSchema)(options.unevaluatedProperties) || allObjects
        ? { ...options, ...clonedUnevaluatedProperties, [index_3.Kind]: 'Intersect', type: 'object', allOf: (0, type_1.CloneRest)(T) }
        : { ...options, ...clonedUnevaluatedProperties, [index_3.Kind]: 'Intersect', allOf: (0, type_1.CloneRest)(T) });
}
exports.Intersect = Intersect;
