import type { TSchema } from '../schema/index';
import type { Ensure } from '../helpers/index';
import { type TLiteral, TLiteralValue } from '../literal/index';
import { type TNumber } from '../number/index';
import { KeyOfStringResolve } from './keyof-string';
import { UnionResolve } from '../union/index';
type FromLiterals<T extends TLiteralValue[]> = (T extends [infer L extends TLiteralValue, ...infer R extends TLiteralValue[]] ? L extends '[number]' ? [TNumber, ...FromLiterals<R>] : [TLiteral<L>, ...FromLiterals<R>] : []);
declare function FromLiterals<T extends TLiteralValue[]>(T: [...T]): FromLiterals<T>;
export type KeyOfTypeResolve<T extends TSchema> = (Ensure<UnionResolve<FromLiterals<KeyOfStringResolve<T>>>>);
export declare function KeyOfTypeResolve<T extends TSchema>(T: T): KeyOfTypeResolve<T>;
export {};
