"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeyOfTypeResolve = void 0;
const index_1 = require("../literal/index");
const index_2 = require("../number/index");
const keyof_string_1 = require("./keyof-string");
const index_3 = require("../union/index");
function FromLiterals(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? L === '[number]'
            ? [(0, index_2.Number)(), ...FromLiterals(R)]
            : [(0, index_1.Literal)(L), ...FromLiterals(R)]
        : []);
}
function KeyOfTypeResolve(T) {
    return ((0, index_3.UnionResolve)(FromLiterals((0, keyof_string_1.KeyOfStringResolve)(T))));
}
exports.KeyOfTypeResolve = KeyOfTypeResolve;
