import type { TSchema } from '../schema/index';
import type { Evaluate } from '../helpers/index';
import type { Static } from '../static/index';
import { type TObject, type TProperties } from '../object/index';
import { IndexedKeyResolve } from '../indexed/indexed-key';
import { Kind } from '../symbols/index';
export interface TMappedKey<T extends PropertyKey[] = PropertyKey[]> extends TSchema {
    [Kind]: 'MappedKey';
    static: T[number];
    anyOf: [];
}
export type MappedFunction<K extends PropertyKey[], I = TMappedKey<K>> = (T: I) => TSchema;
export type MappedResultProperties<K extends PropertyKey[], T extends TSchema> = K extends [infer L extends string, ...infer R extends PropertyKey[]] ? {
    [_ in `${L}`]: T;
} & MappedResultProperties<R, T> : {};
export type UnevaluatedMappedResult<T extends TSchema> = T;
export type EvaluatedMappedResult<K extends PropertyKey[], T extends TSchema> = T;
export interface TMappedResult<K extends PropertyKey[], F extends MappedFunction<K>, S extends TSchema = ReturnType<F>, R extends TSchema = EvaluatedMappedResult<K, S>, P extends TProperties = Evaluate<MappedResultProperties<K, R>>, O extends TObject = TObject<P>> extends TSchema {
    [Kind]: 'MappedResult';
    static: Static<O, this['params']>;
    properties: P;
}
export declare function Mapped<K extends TSchema, I extends PropertyKey[] = IndexedKeyResolve<K>, F extends MappedFunction<I> = MappedFunction<I>, R extends TMappedResult<I, F> = TMappedResult<I, F>>(key: K, map: F): R;
export declare function Mapped<K extends PropertyKey[], F extends MappedFunction<K> = MappedFunction<K>, R extends TMappedResult<K, F> = TMappedResult<K, F>>(key: [...K], map: F): R;
