"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mapped = void 0;
const index_1 = require("../object/index");
const index_2 = require("../literal/index");
const indexed_key_1 = require("../indexed/indexed-key");
const type_1 = require("../guard/type");
const index_3 = require("../symbols/index");
function Mapped(key, map) {
    const keys = (0, type_1.TSchema)(key) ? (0, indexed_key_1.IndexedKeyResolve)(key) : key;
    const anyOf = keys.map(key => (0, index_2.Literal)(key));
    const mapped = { [index_3.Kind]: 'MappedKey', anyOf };
    const properties = keys.reduce((acc, key) => {
        return { ...acc, [key]: map(mapped) };
    }, {});
    return (0, index_1.Object)(properties);
}
exports.Mapped = Mapped;
