"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionalFromUnion = exports.OptionalFromIntersect = void 0;
const index_1 = require("../intersect/index");
const index_2 = require("../union/index");
const index_3 = require("../optional/index");
const index_4 = require("../discard/index");
const index_5 = require("../symbols/index");
const type_1 = require("../guard/type");
function IsOptionalFromIntersect(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? (0, type_1.TOptional)(L)
            ? IsOptionalFromIntersect(R)
            : false
        : true);
}
function IsOptionalFromUnion(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? (0, type_1.TOptional)(L)
            ? true
            : IsOptionalFromUnion(R)
        : false);
}
function RemoveOptionalFromRest(T) {
    return (T.map(T => RemoveOptionalFromSchema(T)));
}
function RemoveOptionalFromSchema(T) {
    return ((0, index_4.Discard)(T, [index_5.OptionalKind]));
}
function OptionalFromIntersect(T) {
    const D = RemoveOptionalFromRest(T);
    return (IsOptionalFromIntersect(T)
        ? (0, index_3.Optional)((0, index_1.Intersect)(D))
        : (0, index_1.Intersect)(T));
}
exports.OptionalFromIntersect = OptionalFromIntersect;
function OptionalFromUnion(T) {
    const D = RemoveOptionalFromRest(T);
    return (IsOptionalFromUnion(T)
        ? (0, index_3.Optional)((0, index_2.Union)(D))
        : (0, index_2.Union)(T));
}
exports.OptionalFromUnion = OptionalFromUnion;
