"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperatorUnionMany = exports.OperatorIntersectMany = exports.OperatorComplement = exports.OperatorUnion = exports.OperatorIntersect = exports.OperatorDistinct = exports.OperatorSubset = exports.OperatorIncludes = void 0;
function OperatorIncludes(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? S === L
            ? true
            : OperatorIncludes(R, S)
        : false);
}
exports.OperatorIncludes = OperatorIncludes;
function OperatorSubset(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? OperatorSubset(R, S)
            : false
        : true);
}
exports.OperatorSubset = OperatorSubset;
function OperatorDistinct(T, Acc = []) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(Acc, L) === false
            ? OperatorDistinct(R, [...Acc, L])
            : OperatorDistinct(R, [...Acc])
        : Acc);
}
exports.OperatorDistinct = OperatorDistinct;
function OperatorIntersect(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [L, ...OperatorIntersect(R, S)]
            : [...OperatorIntersect(R, S)]
        : []);
}
exports.OperatorIntersect = OperatorIntersect;
function OperatorUnion(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [...OperatorUnion(R, S)]
            : [L, ...OperatorUnion(R, S)]
        : S);
}
exports.OperatorUnion = OperatorUnion;
function OperatorComplement(T, S) {
    const [L, ...R] = T;
    return (T.length > 0
        ? OperatorIncludes(S, L) === true
            ? [...OperatorComplement(R, S)]
            : [L, ...OperatorComplement(R, S)]
        : []);
}
exports.OperatorComplement = OperatorComplement;
function OperatorIntersectMany(T) {
    return (T.length === 1
        ? T[0]
        : (() => {
            const [L, ...R] = T;
            return (L.length > 0
                ? OperatorIntersect(L, OperatorIntersectMany(R))
                : []);
        })());
}
exports.OperatorIntersectMany = OperatorIntersectMany;
function OperatorUnionMany(T) {
    return (T.length === 1
        ? T[0]
        : (() => {
            const [L, ...R] = T;
            return T.length > 0 ? OperatorUnion(L, OperatorUnionMany(R)) : [];
        })());
}
exports.OperatorUnionMany = OperatorUnionMany;
