"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Required = exports.RequiredResolve = void 0;
const index_1 = require("../intersect/index");
const index_2 = require("../union/index");
const index_3 = require("../object/index");
const index_4 = require("../symbols/index");
const type_1 = require("../clone/type");
const index_5 = require("../discard/index");
const type_2 = require("../guard/type");
function FromIntersect(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [RequiredResolve(L), ...FromIntersect(R)]
        : []);
}
function FromUnion(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? [RequiredResolve(L), ...FromUnion(R)]
        : []);
}
function FromProperties(T) {
    return globalThis.Object.getOwnPropertyNames(T).reduce((Acc, K) => {
        return { ...Acc, [K]: (0, index_5.Discard)(T[K], [index_4.OptionalKind]) };
    }, {});
}
function RequiredResolve(T) {
    return ((0, type_2.TIntersect)(T) ? (0, index_1.Intersect)(FromIntersect(T.allOf)) :
        (0, type_2.TUnion)(T) ? (0, index_2.Union)(FromUnion(T.anyOf)) :
            (0, type_2.TObject)(T) ? (0, index_3.Object)(FromProperties(T.properties)) :
                (0, index_3.Object)({}));
}
exports.RequiredResolve = RequiredResolve;
function Required(T, options = {}) {
    const D = (0, index_5.Discard)(T, [index_4.TransformKind, '$id', 'required']);
    const R = (0, type_1.CloneType)(RequiredResolve(T), options);
    return { ...D, ...R };
}
exports.Required = Required;
