import { Kind, Hint, ReadonlyKind, OptionalKind } from '../symbols/index';
export interface SchemaOptions {
    $schema?: string;
    $id?: string;
    title?: string;
    description?: string;
    default?: any;
    examples?: any;
    readOnly?: boolean;
    writeOnly?: boolean;
    [prop: string]: any;
}
export interface TKind {
    [Kind]: string;
}
export interface TSchema extends SchemaOptions, TKind {
    [ReadonlyKind]?: string;
    [OptionalKind]?: string;
    [Hint]?: string;
    params: unknown[];
    static: unknown;
}
