import type { TTemplateLiteral, TTemplateLiteralKind } from './index';
import type { TUnion } from '../union/index';
import type { TString } from '../string/index';
import type { TBoolean } from '../boolean/index';
import type { TNumber } from '../number/index';
import type { TInteger } from '../integer/index';
import type { TBigInt } from '../bigint/index';
import type { TLiteral } from '../literal/index';
import type { Expression } from './parser';
export declare class TemplateLiteralFiniteError extends Error {
}
type IsTemplateLiteralFiniteCheck<T> = T extends TTemplateLiteral<infer U extends TTemplateLiteralKind[]> ? IsTemplateLiteralFiniteArray<U> : T extends TUnion<infer U extends TTemplateLiteralKind[]> ? IsTemplateLiteralFiniteArray<U> : T extends TString ? false : T extends TBoolean ? false : T extends TNumber ? false : T extends TInteger ? false : T extends TBigInt ? false : T extends TLiteral ? true : false;
type IsTemplateLiteralFiniteArray<T extends TTemplateLiteralKind[]> = T extends [infer L extends TTemplateLiteralKind, ...infer R extends TTemplateLiteralKind[]] ? IsTemplateLiteralFiniteCheck<L> extends false ? false : IsTemplateLiteralFiniteArray<R> : true;
export type IsTemplateLiteralFinite<T> = T extends TTemplateLiteral<infer U> ? IsTemplateLiteralFiniteArray<U> : false;
export declare function IsTemplateLiteralFinite(expression: Expression): boolean;
export {};
