"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsTemplateLiteralFinite = exports.TemplateLiteralFiniteError = void 0;
class TemplateLiteralFiniteError extends Error {
}
exports.TemplateLiteralFiniteError = TemplateLiteralFiniteError;
function IsNumberExpression(expression) {
    return (expression.type === 'or' &&
        expression.expr.length === 2 &&
        expression.expr[0].type === 'const' &&
        expression.expr[0].const === '0' &&
        expression.expr[1].type === 'const' &&
        expression.expr[1].const === '[1-9][0-9]*');
}
function IsBooleanExpression(expression) {
    return (expression.type === 'or' &&
        expression.expr.length === 2 &&
        expression.expr[0].type === 'const' &&
        expression.expr[0].const === 'true' &&
        expression.expr[1].type === 'const' &&
        expression.expr[1].const === 'false');
}
function IsStringExpression(expression) {
    return expression.type === 'const' && expression.const === '.*';
}
function IsTemplateLiteralFinite(expression) {
    return (IsBooleanExpression(expression) ? true :
        IsNumberExpression(expression) || IsStringExpression(expression) ? false :
            (expression.type === 'and') ? expression.expr.every((expr) => IsTemplateLiteralFinite(expr)) :
                (expression.type === 'or') ? expression.expr.every((expr) => IsTemplateLiteralFinite(expr)) :
                    (expression.type === 'const') ? true :
                        (() => { throw new TemplateLiteralFiniteError(`Unknown expression type`); })());
}
exports.IsTemplateLiteralFinite = IsTemplateLiteralFinite;
