"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TemplateLiteralPattern = exports.TemplateLiteralPatternError = void 0;
const index_1 = require("../patterns/index");
const index_2 = require("../symbols/index");
const type_1 = require("../guard/type");
class TemplateLiteralPatternError extends Error {
}
exports.TemplateLiteralPatternError = TemplateLiteralPatternError;
function Escape(value) {
    return value.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
}
function Visit(schema, acc) {
    return ((0, type_1.TTemplateLiteral)(schema) ? schema.pattern.slice(1, schema.pattern.length - 1) :
        (0, type_1.TUnion)(schema) ? `(${schema.anyOf.map((schema) => Visit(schema, acc)).join('|')})` :
            (0, type_1.TNumber)(schema) ? `${acc}${index_1.PatternNumber}` :
                (0, type_1.TInteger)(schema) ? `${acc}${index_1.PatternNumber}` :
                    (0, type_1.TBigInt)(schema) ? `${acc}${index_1.PatternNumber}` :
                        (0, type_1.TString)(schema) ? `${acc}${index_1.PatternString}` :
                            (0, type_1.TLiteral)(schema) ? `${acc}${Escape(schema.const.toString())}` :
                                (0, type_1.TBoolean)(schema) ? `${acc}${index_1.PatternBoolean}` :
                                    (() => { throw new TemplateLiteralPatternError(`Unexpected Kind '${schema[index_2.Kind]}'`); })());
}
function TemplateLiteralPattern(kinds) {
    return `^${kinds.map((schema) => Visit(schema, '')).join('')}\$`;
}
exports.TemplateLiteralPattern = TemplateLiteralPattern;
