"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TemplateLiteralToUnion = void 0;
const index_1 = require("../union/index");
const index_2 = require("../literal/index");
const index_3 = require("../string/index");
const generate_1 = require("./generate");
const parser_1 = require("./parser");
const finite_1 = require("./finite");
function TemplateLiteralToUnion(template) {
    const expression = (0, parser_1.TemplateLiteralParseExact)(template.pattern);
    if (!(0, finite_1.IsTemplateLiteralFinite)(expression))
        return (0, index_3.String)();
    const literals = [...(0, generate_1.TemplateLiteralGenerate)(expression)].map((value) => (0, index_2.Literal)(value));
    return (0, index_1.Union)(literals);
}
exports.TemplateLiteralToUnion = TemplateLiteralToUnion;
