import { JsonTypeBuilder } from './json';
import { type TAsyncIterator } from '../async-iterator/index';
import { type TAwaited } from '../awaited/index';
import { type TBigInt, type BigIntOptions } from '../bigint/index';
import { type TConstructor } from '../constructor/index';
import { type TConstructorParameters } from '../constructor-parameters/index';
import { type TDate, type DateOptions } from '../date/index';
import { type TFunction } from '../function/index';
import { type TInstanceType } from '../instance-type/index';
import { type TIterator } from '../iterator/index';
import { type TParameters } from '../parameters/index';
import { type TPromise } from '../promise/index';
import { type TRegExp } from '../regexp/index';
import { type TReturnType } from '../return-type/index';
import { type TSchema, type SchemaOptions } from '../schema/index';
import { type TSymbol } from '../symbol/index';
import { type TUint8Array, type Uint8ArrayOptions } from '../uint8array/index';
import { type TUndefined } from '../undefined/index';
import { type TVoid } from '../void/index';
export declare class JavaScriptTypeBuilder extends JsonTypeBuilder {
    AsyncIterator<T extends TSchema>(items: T, options?: SchemaOptions): TAsyncIterator<T>;
    Awaited<T extends TSchema>(schema: T, options?: SchemaOptions): TAwaited<T>;
    BigInt(options?: BigIntOptions): TBigInt;
    ConstructorParameters<T extends TConstructor<TSchema[], TSchema>>(schema: T, options?: SchemaOptions): TConstructorParameters<T>;
    Constructor<T extends TSchema[], U extends TSchema>(parameters: [...T], returns: U, options?: SchemaOptions): TConstructor<T, U>;
    Date(options?: DateOptions): TDate;
    Function<T extends TSchema[], U extends TSchema>(parameters: [...T], returns: U, options?: SchemaOptions): TFunction<T, U>;
    InstanceType<T extends TConstructor<any[], any>>(schema: T, options?: SchemaOptions): TInstanceType<T>;
    Iterator<T extends TSchema>(items: T, options?: SchemaOptions): TIterator<T>;
    Parameters<T extends TFunction<TSchema[], TSchema>>(schema: T, options?: SchemaOptions): TParameters<T>;
    Promise<T extends TSchema>(item: T, options?: SchemaOptions): TPromise<T>;
    RegExp(pattern: string, options?: SchemaOptions): TRegExp;
    RegExp(regex: RegExp, options?: SchemaOptions): TRegExp;
    ReturnType<T extends TFunction<any[], any>>(schema: T, options?: SchemaOptions): TReturnType<T>;
    Symbol(options?: SchemaOptions): TSymbol;
    Undefined(options?: SchemaOptions): TUndefined;
    Uint8Array(options?: Uint8ArrayOptions): TUint8Array;
    Void(options?: SchemaOptions): TVoid;
}
