"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JavaScriptTypeBuilder = void 0;
const json_1 = require("./json");
const index_1 = require("../async-iterator/index");
const index_2 = require("../awaited/index");
const index_3 = require("../bigint/index");
const index_4 = require("../constructor/index");
const index_5 = require("../constructor-parameters/index");
const index_6 = require("../date/index");
const index_7 = require("../function/index");
const index_8 = require("../instance-type/index");
const index_9 = require("../iterator/index");
const index_10 = require("../parameters/index");
const index_11 = require("../promise/index");
const index_12 = require("../regexp/index");
const index_13 = require("../return-type/index");
const index_14 = require("../symbol/index");
const index_15 = require("../uint8array/index");
const index_16 = require("../undefined/index");
const index_17 = require("../void/index");
class JavaScriptTypeBuilder extends json_1.JsonTypeBuilder {
    AsyncIterator(items, options = {}) {
        return (0, index_1.AsyncIterator)(items, options);
    }
    Awaited(schema, options = {}) {
        return (0, index_2.Awaited)(schema, options);
    }
    BigInt(options = {}) {
        return (0, index_3.BigInt)(options);
    }
    ConstructorParameters(schema, options = {}) {
        return (0, index_5.ConstructorParameters)(schema, options);
    }
    Constructor(parameters, returns, options) {
        return (0, index_4.Constructor)(parameters, returns, options);
    }
    Date(options = {}) {
        return (0, index_6.Date)(options);
    }
    Function(parameters, returns, options) {
        return (0, index_7.Function)(parameters, returns, options);
    }
    InstanceType(schema, options = {}) {
        return (0, index_8.InstanceType)(schema, options);
    }
    Iterator(items, options = {}) {
        return (0, index_9.Iterator)(items, options);
    }
    Parameters(schema, options = {}) {
        return (0, index_10.Parameters)(schema, options);
    }
    Promise(item, options = {}) {
        return (0, index_11.Promise)(item, options);
    }
    RegExp(unresolved, options = {}) {
        return (0, index_12.RegExp)(unresolved, options);
    }
    ReturnType(schema, options = {}) {
        return (0, index_13.ReturnType)(schema, options);
    }
    Symbol(options) {
        return (0, index_14.Symbol)(options);
    }
    Undefined(options = {}) {
        return (0, index_16.Undefined)(options);
    }
    Uint8Array(options = {}) {
        return (0, index_15.Uint8Array)(options);
    }
    Void(options = {}) {
        return (0, index_17.Void)(options);
    }
}
exports.JavaScriptTypeBuilder = JavaScriptTypeBuilder;
