"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonTypeBuilder = void 0;
const index_1 = require("../any/index");
const index_2 = require("../array/index");
const index_3 = require("../boolean/index");
const index_4 = require("../composite/index");
const index_5 = require("../const/index");
const index_6 = require("../deref/index");
const index_7 = require("../enum/index");
const index_8 = require("../exclude/index");
const index_9 = require("../extends/index");
const index_10 = require("../extract/index");
const index_11 = require("../indexed/index");
const index_12 = require("../integer/index");
const index_13 = require("../intersect/index");
const index_14 = require("../intrinsic/index");
const index_15 = require("../keyof/index");
const index_16 = require("../literal/index");
const index_17 = require("../never/index");
const index_18 = require("../not/index");
const index_19 = require("../null/index");
const index_20 = require("../number/index");
const index_21 = require("../object/index");
const index_22 = require("../omit/index");
const index_23 = require("../optional/index");
const index_24 = require("../partial/index");
const index_25 = require("../pick/index");
const index_26 = require("../readonly/index");
const index_27 = require("../readonly-optional/index");
const index_28 = require("../record/index");
const index_29 = require("../recursive/index");
const index_30 = require("../ref/index");
const index_31 = require("../required/index");
const index_32 = require("../rest/index");
const index_33 = require("../strict/index");
const index_34 = require("../string/index");
const index_35 = require("../template-literal/index");
const index_36 = require("../transform/index");
const index_37 = require("../tuple/index");
const index_38 = require("../union/index");
const index_39 = require("../unknown/index");
const index_40 = require("../unsafe/index");
class JsonTypeBuilder {
    Strict(schema) {
        return (0, index_33.Strict)(schema);
    }
    ReadonlyOptional(schema) {
        return (0, index_27.ReadonlyOptional)(schema);
    }
    Readonly(schema) {
        return (0, index_26.Readonly)(schema);
    }
    Optional(schema) {
        return (0, index_23.Optional)(schema);
    }
    Any(options = {}) {
        return (0, index_1.Any)(options);
    }
    Array(schema, options = {}) {
        return (0, index_2.Array)(schema, options);
    }
    Boolean(options = {}) {
        return (0, index_3.Boolean)(options);
    }
    Capitalize(schema, options = {}) {
        return (0, index_14.Capitalize)(schema, options);
    }
    Composite(objects, options) {
        return (0, index_4.Composite)(objects, options);
    }
    Const(value, options = {}) {
        return (0, index_5.Const)(value, options);
    }
    Deref(schema, references) {
        return (0, index_6.Deref)(schema, references);
    }
    Enum(item, options = {}) {
        return (0, index_7.Enum)(item, options);
    }
    Extends(left, right, trueType, falseType, options = {}) {
        return (0, index_9.Extends)(left, right, trueType, falseType, options);
    }
    Exclude(unionType, excludedMembers, options = {}) {
        return (0, index_8.Exclude)(unionType, excludedMembers, options);
    }
    Extract(type, union, options = {}) {
        return (0, index_10.Extract)(type, union, options);
    }
    Index(schema, unresolved, options = {}) {
        return (0, index_11.Index)(schema, unresolved, options);
    }
    Integer(options = {}) {
        return (0, index_12.Integer)(options);
    }
    Intersect(T, options = {}) {
        return (0, index_13.Intersect)(T, options);
    }
    KeyOf(schema, options = {}) {
        return (0, index_15.KeyOf)(schema, options);
    }
    Literal(value, options = {}) {
        return (0, index_16.Literal)(value, options);
    }
    Lowercase(schema, options = {}) {
        return (0, index_14.Lowercase)(schema, options);
    }
    Never(options = {}) {
        return (0, index_17.Never)(options);
    }
    Not(schema, options) {
        return (0, index_18.Not)(schema, options);
    }
    Null(options = {}) {
        return (0, index_19.Null)(options);
    }
    Number(options = {}) {
        return (0, index_20.Number)(options);
    }
    Object(properties, options = {}) {
        return (0, index_21.Object)(properties, options);
    }
    Omit(schema, unresolved, options = {}) {
        return (0, index_22.Omit)(schema, unresolved, options);
    }
    Partial(schema, options = {}) {
        return (0, index_24.Partial)(schema, options);
    }
    Pick(schema, unresolved, options = {}) {
        return (0, index_25.Pick)(schema, unresolved, options);
    }
    Record(key, schema, options = {}) {
        return (0, index_28.Record)(key, schema);
    }
    Recursive(callback, options = {}) {
        return (0, index_29.Recursive)(callback, options);
    }
    Ref(unresolved, options = {}) {
        return (0, index_30.Ref)(unresolved, options);
    }
    Required(schema, options = {}) {
        return (0, index_31.Required)(schema, options);
    }
    Rest(schema) {
        return (0, index_32.Rest)(schema);
    }
    String(options = {}) {
        return (0, index_34.String)(options);
    }
    TemplateLiteral(unresolved, options = {}) {
        return (0, index_35.TemplateLiteral)(unresolved, options);
    }
    Transform(schema) {
        return (0, index_36.Transform)(schema);
    }
    Tuple(items, options = {}) {
        return (0, index_37.Tuple)(items, options);
    }
    Uncapitalize(schema, options = {}) {
        return (0, index_14.Uncapitalize)(schema, options);
    }
    Union(schemas, options = {}) {
        return (0, index_38.Union)(schemas, options);
    }
    Unknown(options = {}) {
        return (0, index_39.Unknown)(options);
    }
    Unsafe(options = {}) {
        return (0, index_40.Unsafe)(options);
    }
    Uppercase(schema, options = {}) {
        return (0, index_14.Uppercase)(schema, options);
    }
}
exports.JsonTypeBuilder = JsonTypeBuilder;
