import type { TSchema } from '../../type/schema/index';
import type { Static } from '../../type/static/index';
export declare class ValueCreateUnknownTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCreateNeverTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCreateNotTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCreateIntersectTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCreateTempateLiteralTypeError extends Error {
    readonly schema: TSchema;
    constructor(schema: TSchema);
}
export declare class ValueCreateRecursiveInstantiationError extends Error {
    readonly schema: TSchema;
    readonly recursiveMaxDepth: number;
    constructor(schema: TSchema, recursiveMaxDepth: number);
}
export declare function Create<T extends TSchema>(schema: T, references: TSchema[]): Static<T>;
export declare function Create<T extends TSchema>(schema: T): Static<T>;
