"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Deref = exports.TypeDereferenceError = void 0;
class TypeDereferenceError extends Error {
    constructor(schema) {
        super(`Unable to dereference schema with $id '${schema.$id}'`);
        this.schema = schema;
    }
}
exports.TypeDereferenceError = TypeDereferenceError;
function Deref(schema, references) {
    const index = references.findIndex((target) => target.$id === schema.$ref);
    if (index === -1)
        throw new TypeDereferenceError(schema);
    return references[index];
}
exports.Deref = Deref;
