export type ObjectType = Record<PropertyKey, unknown>;
export type ArrayType = unknown[];
export type ValueType = null | undefined | symbol | bigint | number | boolean | string;
export type TypedArrayType = Int8Array | Uint8Array | Uint8ClampedArray | Int16Array | Uint16Array | Int32Array | Uint32Array | Float32Array | Float64Array | BigInt64Array | BigUint64Array;
export declare function IsAsyncIterator(value: unknown): value is AsyncIterableIterator<any>;
export declare function IsIterator(value: unknown): value is IterableIterator<any>;
export declare function IsTypedArray(value: unknown): value is TypedArrayType;
export declare function IsPromise(value: unknown): value is Promise<unknown>;
export declare function IsUint8Array(value: unknown): value is Uint8Array;
export declare function IsDate(value: unknown): value is Date;
export declare function HasPropertyKey<K extends PropertyKey>(value: Record<any, unknown>, key: K): value is ObjectType & Record<K, unknown>;
export declare function IsPlainObject(value: unknown): value is ObjectType;
export declare function IsObject(value: unknown): value is ObjectType;
export declare function IsArray(value: unknown): value is ArrayType;
export declare function IsUndefined(value: unknown): value is undefined;
export declare function IsNull(value: unknown): value is null;
export declare function IsBoolean(value: unknown): value is boolean;
export declare function IsNumber(value: unknown): value is number;
export declare function IsInteger(value: unknown): value is number;
export declare function IsBigInt(value: unknown): value is bigint;
export declare function IsString(value: unknown): value is string;
export declare function IsFunction(value: unknown): value is Function;
export declare function IsSymbol(value: unknown): value is symbol;
export declare function IsValueType(value: unknown): value is ValueType;
