import { type Mutable } from '../mutate/index';
import { Edit } from '../delta/index';
import { ValueErrorIterator } from '../../errors/index';
import type { TSchema } from '../../type/schema/index';
import type { Static, StaticDecode, StaticEncode } from '../../type/static/index';
export declare function Cast<T extends TSchema>(schema: T, references: TSchema[], value: unknown): Static<T>;
export declare function Cast<T extends TSchema>(schema: T, value: unknown): Static<T>;
export declare function Create<T extends TSchema>(schema: T, references: TSchema[]): Static<T>;
export declare function Create<T extends TSchema>(schema: T): Static<T>;
export declare function Check<T extends TSchema>(schema: T, references: TSchema[], value: unknown): value is Static<T>;
export declare function Check<T extends TSchema>(schema: T, value: unknown): value is Static<T>;
export declare function Clean<T extends TSchema>(schema: T, references: TSchema[], value: unknown): unknown;
export declare function Clean<T extends TSchema>(schema: T, value: unknown): unknown;
export declare function Convert<T extends TSchema>(schema: T, references: TSchema[], value: unknown): unknown;
export declare function Convert<T extends TSchema>(schema: T, value: unknown): unknown;
export declare function Clone<T>(value: T): T;
export declare function Decode<T extends TSchema, R = StaticDecode<T>>(schema: T, references: TSchema[], value: unknown): R;
export declare function Decode<T extends TSchema, R = StaticDecode<T>>(schema: T, value: unknown): R;
export declare function Default<T extends TSchema>(schema: T, references: TSchema[], value: unknown): unknown;
export declare function Default<T extends TSchema>(schema: T, value: unknown): unknown;
export declare function Encode<T extends TSchema, R = StaticEncode<T>>(schema: T, references: TSchema[], value: unknown): R;
export declare function Encode<T extends TSchema, R = StaticEncode<T>>(schema: T, value: unknown): R;
export declare function Errors<T extends TSchema>(schema: T, references: TSchema[], value: unknown): ValueErrorIterator;
export declare function Errors<T extends TSchema>(schema: T, value: unknown): ValueErrorIterator;
export declare function Equal<T>(left: T, right: unknown): right is T;
export declare function Diff(current: unknown, next: unknown): Edit[];
export declare function Hash(value: unknown): bigint;
export declare function Patch<T = any>(current: unknown, edits: Edit[]): T;
export declare function Mutate(current: Mutable, next: Mutable): void;
