"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mutate = exports.Patch = exports.Hash = exports.Diff = exports.Equal = exports.Errors = exports.Encode = exports.Default = exports.Decode = exports.Clone = exports.Convert = exports.Clean = exports.Check = exports.Create = exports.Cast = void 0;
const index_1 = require("../transform/index");
const index_2 = require("../mutate/index");
const index_3 = require("../hash/index");
const index_4 = require("../equal/index");
const index_5 = require("../cast/index");
const index_6 = require("../clone/index");
const index_7 = require("../convert/index");
const index_8 = require("../create/index");
const index_9 = require("../clean/index");
const index_10 = require("../check/index");
const index_11 = require("../default/index");
const index_12 = require("../delta/index");
const index_13 = require("../../errors/index");
function Cast(...args) {
    return index_5.Cast.apply(index_5.Cast, args);
}
exports.Cast = Cast;
function Create(...args) {
    return index_8.Create.apply(index_8.Create, args);
}
exports.Create = Create;
function Check(...args) {
    return index_10.Check.apply(index_10.Check, args);
}
exports.Check = Check;
function Clean(...args) {
    return index_9.Clean.apply(index_9.Clean, args);
}
exports.Clean = Clean;
function Convert(...args) {
    return index_7.Convert.apply(index_7.Convert, args);
}
exports.Convert = Convert;
function Clone(value) {
    return (0, index_6.Clone)(value);
}
exports.Clone = Clone;
function Decode(...args) {
    const [schema, references, value] = args.length === 3 ? [args[0], args[1], args[2]] : [args[0], [], args[1]];
    if (!Check(schema, references, value))
        throw new index_1.TransformDecodeCheckError(schema, value, Errors(schema, references, value).First());
    return (0, index_1.Decode)(schema, references, value);
}
exports.Decode = Decode;
function Default(...args) {
    return index_11.Default.apply(index_11.Default, args);
}
exports.Default = Default;
function Encode(...args) {
    const [schema, references, value] = args.length === 3 ? [args[0], args[1], args[2]] : [args[0], [], args[1]];
    const encoded = (0, index_1.Encode)(schema, references, value);
    if (!Check(schema, references, encoded))
        throw new index_1.TransformEncodeCheckError(schema, value, Errors(schema, references, value).First());
    return encoded;
}
exports.Encode = Encode;
function Errors(...args) {
    return index_13.Errors.apply(index_13.Errors, args);
}
exports.Errors = Errors;
function Equal(left, right) {
    return (0, index_4.Equal)(left, right);
}
exports.Equal = Equal;
function Diff(current, next) {
    return (0, index_12.Diff)(current, next);
}
exports.Diff = Diff;
function Hash(value) {
    return (0, index_3.Hash)(value);
}
exports.Hash = Hash;
function Patch(current, edits) {
    return (0, index_12.Patch)(current, edits);
}
exports.Patch = Patch;
function Mutate(current, next) {
    (0, index_2.Mutate)(current, next);
}
exports.Mutate = Mutate;
